=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: xen
 Section: kernel
 Priority: optional
-Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Xen Team <pkg-xen-devel@lists.alioth.debian.org>
 Uploaders: Guido Trotter <ultrotter@debian.org>, Bastian Blank <waldi@debian.org>
 Standards-Version: 3.9.4
 Build-Depends: autotools-dev, debhelper (>> 9), dpkg-dev (>= 1.16.0~), lsb-release, python-dev, bcc [i386 amd64], gcc-multilib [i386 amd64], e2fslibs-dev, iasl [i386 amd64], seabios (>= 1.7.4-2~) [i386 amd64], libaio-dev, libfdt-dev [armhf arm64], libglib2.0-dev, liblzma-dev, libncurses5-dev, libyajl-dev, libssl-dev, pkg-config, uuid-dev, zlib1g-dev
@@ -86,6 +87,8 @@
 Package: xen-hypervisor-4.5-amd64
 Architecture: amd64 i386
 Provides: xen-hypervisor, xen-hypervisor-4.5, xen-hypervisor-amd64
+Breaks: xen-hypervisor-4.4-amd64 (<< 4.5.0)
+Replaces: xen-hypervisor-4.4-amd64 (<< 4.5.0)
 Depends: ${misc:Depends}
 Recommends: xen-utils-4.5
 Description: Xen Hypervisor on AMD64
@@ -149,3 +152,24 @@
  This package depends on the latest Xen hypervisor for use on ARMHF and the
  Xen utils.
 
+#
+# Transitional packages to enforce upgrade (keep around until after W+1)
+#
+Package: xen-hypervisor-4.4-amd64
+Architecture: amd64 i386
+Depends: xen-system-amd64
+Section: oldlibs
+Description: Transitional package for upgrade
+
+Package: xen-hypervisor-4.4-armhf
+Architecture: armhf
+Depends: xen-system-armhf
+Section: oldlibs
+Description: Transitional package for upgrade
+
+Package: xen-hypervisor-4.4-arm64
+Architecture: arm64
+Depends: xen-system-arm64
+Section: oldlibs
+Description: Transitional package for upgrade
+
